#
# topic-mod.R, 22 Jan 22

library("stm")

tinfo=read.csv("task-info-ascii.csv", as.is=TRUE)

proc=textProcessor(tinfo$Summary, metadata=tinfo, removenumbers=FALSE, wordLengths=c(3, Inf))

postprep=prepDocuments(proc$documents, proc$vocab, proc$meta)

# This can take an hour or so of cpu
# sip_sK1 = searchK(documents = postprep$documents, vocab=postprep$vocab, K=c(5, 50),
# 				prevalence =~ ProjectCode+Category+ DeveloperID,
#				data=postprep$meta)


sip_stm15 = stm(documents = postprep$documents, vocab=postprep$vocab,
				K=15, prevalence =~ ProjectCode+Category+DeveloperID,
				max.em.its=100, data=postprep$meta,
				init.type="Spectral")

sip_stm20 = stm(documents = postprep$documents, vocab=postprep$vocab,
				K=20, prevalence =~ ProjectCode+DeveloperID,
				max.em.its=75, data=postprep$meta,
				init.type="Spectral")

plot.STM(sip_stm20, type="labels")
plot.STM(sip_stm20, type="summary")

sip_sel1 = selectModel(documents = postprep$documents, vocab = postprep$vocab,
				K=20, prevalence =~ ProjectCode + DeveloperID,
				max.em.its=75, data=postprep$meta,
				init.type="Spectral")

plotModels(sip_sel1, pch=c(1,2,3,4), legend.position="bottomright")

sip_stmc15 = stm(documents = postprep$documents, vocab=postprep$vocab, K=15,
				prevalence= ~ProjectCode+Category+DeveloperID,
				content= ~Category,
				max.em.its=100, data=postprep$meta,
				init.type="Spectral")

plot(sip_stmc15, type="perspective", topics=5)
 

